<template>
    <Page>
        <ScrollView>
            <GridLayout rows="auto,auto,auto">
                <StackLayout class="margin">
                    <Label 
                        text="Imagen" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true">
                    </Label>
                    <StackLayout>    
                        <Image 
                        :src="item.foto" 
                        height="40%" 
                        width="100%"/>
                    </StackLayout>
                    <Label 
                        text="Descripcion" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true"
                        marginTop="10">
                    </Label>
                    <TextView 
                        v-model="item.descripcion" 
                        textWrap="true"
                        borderBottomWidth="3" 
                        borderBottomColor="#cec8c8"/>
                    <Label 
                        text="Actividad" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true"
                        marginTop="10">
                    </Label>
                    <ListPicker :items="actividades.map((e) => { return e.descripcion })" v-model="actividad" />
                    <!-- <Label 
                        text="Tipo de actividad" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true"
                        marginTop="10">
                    </Label>
                    <ListPicker :items="tipos.map((e) => { return e.clave; })" v-model="tipo" /> -->
                    <StackLayout horizontalAlignment="center" v-show="!processing" orientation="horizontal">
                        <Button @tap="$modal.close(false)" text="Cancelar"/>
                        <Button @tap="editarDatos()" text="Editar"/>     
                    </StackLayout>
                </StackLayout>
                <ActivityIndicator :busy="processing" color="#7d00cc" row="0" rowSpan="3"></ActivityIndicator>
            </GridLayout>
        </ScrollView>
    </Page>
</template>

<script>
import store from "../../store";
import { mapGetters } from 'vuex';
import axios from 'axios';
import { urlApi } from '../../main.js';

export default {
    props: ['item'],
    data(){
        return{
            processing: false,
            actividad: 0,
            // tipo: 0,
            // tipos: [],
            actividades: []
        }
    },
    created(){
        // this.obtenerTiposActividad();
        this.obtenerActividades();
    },
    computed:{
        // actividades(){
        //     return store.getters.getItems;
        // },
        // actividad_s:{
        //     get: function(){
        //         return this.actividades.map( actividad => actividad.id ).indexOf(this.item.maintenance_log_id);
        //     },
        //     set: function (newValue){
        //         this.actividad = newValue;
        //     }
        // }
    },
    methods:{
        obtenerActividades(){
            axios.get(urlApi+'/api/v1/mtto/mantenimientos/listado')
            .then(data => {
                this.actividades = data.data;
                this.actividad = this.actividades.map( actividad => actividad.id ).indexOf(this.item.maintenance_id);
            })
            .catch(err => {
                console.log("Error -> " + err.message);
            });
        },
        // obtenerTiposActividad(){
        //     axios.get(urlApi+'/api/v1/mtto/tiposMantenimiento/listado')
        //     .then(data => {
        //         this.tipos = data.data;
        //         this.tipo = this.tipos.map( tipo => tipo.id ).indexOf(this.item.tipo_mantenimiento_id);
        //     })
        //     .catch(err => {
        //         console.log("Error -> " + err.message);
        //     });
        // },
        editarDatos(){
            let actividad;
            let tipo;
            this.processing = true;
            for (let i = 0; i < this.actividades.length; i++) {
                if (this.actividad == i) {
                    actividad = this.actividades[i].id;
                    break;
                }
            }

            // for (let i = 0; i < this.tipos.length; i++) {
            //     if (this.tipo == i) {
            //         tipo = this.tipos[i].id;
            //         break;
            //     }
            // }
            axios.put(urlApi+`/api/v1/mtto/incidences/${this.item.id}/update-incidence`,{
                actividad_id: actividad,
                nombre: this.item.nombre,
                descripcion: this.item.descripcion,
                foto: this.item.foto
            })
            .then(data => {
                this.processing = false;
                console.log('incidencia editada staisfactoriamente');
                this.$modal.close(true);  
            })
            .catch(err => {
                console.log("Error -> " + err.message);
            });
        }
    }
}
</script>

<style scoped>
    .margin{
        margin-left: 20;
        margin-right: 20;
        margin-bottom: 20;
        margin-top: 20;
    }
</style>

